// #autoload
// #name = KillCapCounter
// #description = Small hud that shows your amount of kills and caps.
// #version = 1.5
// #date = 18 March 2003
// #author = Danny de Groot
// #warrior = OddBall-
// #email = dannydg1985@hotmail.com
// #web = http://www.oddballsplace.tk
// #credit = Kaiten
// #category = OddBall
// #include = support/player_support.cs
// #include = support/team_tracker.cs

new GuiControlProfile ("KillCapHudLabelProfile")
{
	fontType = "Verdana";
	fontSize = 16;
	justify = "center";
};	

new GuiControlProfile ("KillCapCountProfile")
{
	fontType = "Verdana";
	fontSize = 16;
	justify = "center";
};

package KillCapCounter {

	function KillCapCounterSetup() {

		new ShellFieldCtrl(KillCapCounter) {
			profile = "GuiConsoleProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "490 46";
			extent = "57 28";
			minExtent = "57 28";
			visible = "1";
			setFirstResponder = "0";

			new GuiTextCtrl(KillCounterLabel) {
				profile = "KillCapHudLabelProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "30 15";
				minExtent = "30 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(KillCounterText) {
				profile = "KillCapCountProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "32 0";
				extent = "25 15";
				minExtent = "25 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "3";
			};
			new GuiTextCtrl(CapCounterLabel) {
				profile = "KillCapHudLabelProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "0 12";
				extent = "35 16";
				minExtent = "35 16";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(CapCounterText) {
				profile = "KillCapCountProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "32 12";
				extent = "25 15";
				minExtent = "25 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "2";
			};

		};

		PlayGui.add(KillCapCounter);

	}

	function KillCountplusOne(%msgType, %msgString, %victimName, %vgen, %vposs, %killerName, %kgen, %kposs, %damageType) {
		%MySelf = PlayerList.getMyName();
		%killer = detag(%killerName);
		%victim = detag(%victimName);

		if ((%killer !$= "" || %victim !$= "") && %killer $= %MySelf)
		{
			if (teamTracker.numTeams > 1)
			{
				%killerteamId = PlayerList.getTeamByName(%killer);
				%victimteamId = PlayerList.getTeamByName(%victim);

				if (%killerteamId != %victimteamId)
					$TotalKills++;
			}
			else
				$TotalKills++;

			KillCounterText.setText($TotalKills);
		}
	}

	function CapCountplusOne(%msgType, %msgString, %playerName, %flagTeam, %flagTeamID) {
		%MySelf = PlayerList.getMyName();
		%capper = detag(%playerName);

		if (%capper $= %MySelf || %capper $= "0")
		{
			$TotalCaps++;
			CapCounterText.setText($TotalCaps);
		}
	}

	function ClientCmdDisplayHuds() {
		parent::ClientCmdDisplayHuds();

		switch$ ($HudMode)
		{
			case "Pilot":
				KillCapCounter.setVisible(true);

			case "Passenger":
				KillCapCounter.setVisible(true);

			case "Object":
				KillCapCounter.setVisible(false);

			case "Observer":
				KillCapCounter.setVisible(false);

			case "PickTeam":
				KillCapCounter.setVisible(false);

			default:
				KillCapCounter.setVisible(true);
		}
	}

	function KillCapCounterReset(%msgType, %msgString, %gameType, %a2, %a3, %a4, %a5, %a6) {
		if (%gameType $= CTFGame)
		{
			$TotalCaps = "0";
			CapCounterLabel.setText("Caps:");
			CapCounterText.setText("0");
		}
		else
		{
			$TotalCaps = "0";
			CapCounterLabel.setText("");
			CapCounterText.setText("");
		}

		$TotalKills = "0";
		KillCounterLabel.setText("Kills:");
		KillCounterText.setText("0");
	}

	function clientCmdTogglePlayHuds(%val) {
		parent::clientCmdTogglePlayHuds(%val);
		KillCapCounter.setVisible(%val);
	}

	function LoadingGui::onWake(%this) {
		parent::onWake(%this);
		if (!$KillCapCounterAddedToHudMover)
		{
			if (isObject(HM) && isObject(HudMover))
				hudmover::addhud(KillCapCounter,"KillCapCounter");

			$KillCapCounterAddedToHudMover = true;
		}
	}

	function DispatchLaunchMode() {
		KillCapCounterSetup();
		addMessageCallBack('MsgLegitKill', KillCountplusOne);
		addMessageCallBack('MsgHeadshotKill', KillCountplusOne);
		addMessageCallBack('msgExplosionKill', KillCountplusOne);
		addMessageCallBack('msgVehicleKill', KillCountplusOne);
		addMessageCallBack('msgTR2Knockdown', KillCountplusOne);
		addMessageCallBack('MsgRearshotKill', KillCountplusOne);
		addMessageCallBack('msgCTurretKill', KillCountplusOne);
		addMessageCallback('MsgCTFFlagCapped', CapCountplusOne);
		addMessageCallback('MsgClientReady', KillCapCounterReset);

		parent::DispatchLaunchMode();
	}

};
activatePackage(KillCapCounter);
